#include <math.h>

int factoriel (int x);
double approsin (double x, int k);
double radiansTodegree (double x);
double racine(double n,int prec);


double racine(double n,int iter)
{
    double x0=n;
    double x1=0;
    int i=0;

    if (n<=0)
        return 0;

    while (i<iter)
    {
        x1=(x0+(n/x0))/2;
        i++;
        x0=x1;
    }
    return x1;
}

int factoriel (int x) {
    int fact;
    if (x==0) fact = 1;
    else {
        fact = x * factoriel (x-1);
    }
    return (fact);
}


double radiansTodegree (double x) {
    return ((x * M_PI)/180);
}

double approsin (double x, int k) {
   double sinx = 0.0, aux=0.0;
   int i;

   //printf ("%lf %lf \n", sinx, aux);

   for (i=0; i<=k; i++) {
       //sinx += pow(-1, i) * ( pow(x, (2*i + 1)) / factoriel (2*i + 1) );
       aux = pow(x, (2*i + 1));
       aux /= factoriel (2*i + 1);
       aux *= pow(-1, i);

    //   printf ("%lf %lf \n", aux, sinx);
       sinx += aux;
   }

   return sinx;
}

