#include <stdio.h>
#define MAX 150
#define MAX_NOTES 20

void calcul_freq (float notes[MAX], int freq[MAX_NOTES]);
void histogramme (int freq[MAX_NOTES]);
float minimun (float A[], int N);
float maximun (float A[], int N);
float moyenne (float A[], int N);


void calcul_freq (float notes[MAX], int freq[MAX_NOTES]) {
    int i,j;

    /* on initialise le vecteur de freq */
    for (i=0; i<MAX_NOTES; i++) {
        freq[i] = 0.0;
    }

    /* on fait la freq */
    for (i=0; i<MAX; i++) {
        for (j=0; j<MAX_NOTES; j++) {
            if (j == (int)notes[i]) {
                 printf ("%f==%d \n ",notes[i], j);
                 freq[j]++;
            }
        }
    }
}

void histogramme (int freq[MAX_NOTES]) {
    int i;
    int spc;

    printf ("\n");
    for (i=0; i<MAX_NOTES; i++) {
        printf ("%d \t: ",i);

        for (spc=0; spc<freq[i]; spc++) {
            printf ("*");
        }
        printf ("\n");
    }
}


/* donne la valeur minimal contenue dans le tableau A de N positions */
float minimum (float A[], int N) {
    int pos_min;   /* position du pos_minimum */
    int i;

    pos_min=0;
    for (i=0; i<N; i++)  {
        if (A[i]<A[pos_min]) pos_min=i;
        printf ("min : %f\n", A[pos_min]);
    }

    return (A[pos_min]);
}

/* donne la valeur max contenue dans le tableau A de N positions */
float maximum (float A[], int N) {
    int pos_max;   /* position du pos_maximum */
    int i;

    pos_max=0;
    for (i=0; i<N; i++) {
        if (A[i]>A[pos_max]) pos_max=i;
    }
    return (A[pos_max]);
}

/* calcul de la mooyenne */
float moyenne (float A[], int N) {
    float moy = 0.0;
    float sum = 0.0;
    int i;

    for (i=0; i<N; i++) {
        sum += A[i];
    }
    moy = sum/N;
    return (moy);
}


int main ()
{
   int i,n=MAX;
   float notes[MAX];
   int freq[MAX_NOTES];
   float min, max, moy;

   printf ("Entrez les notes : ");
   for (i=0; i<n; i++) {
      scanf ("%f", &notes[i]);
   }

   calcul_freq(notes, freq);

   for (i=0; i<MAX_NOTES;i++) {
       printf ("%d ", freq[i]);
   }

   histogramme(freq);

   min = minimum (notes, MAX);
   max = maximum (notes, MAX);
   moy = moyenne (notes, MAX);

   printf ("Min=%f \t Max=%f \t Moyenne=%f\n", min, max, moy);
}
