#include <stdio.h>
#define MAX 50

void entree (int A[], int N);
void affiche (int A[], int N);
int minimun (int A[], int N);
int maximun (int A[], int N);
float moyenne (int A[], int N);

/* entrer un tableau d'entiers A de N positions */
void entree_int (int A[], int N) {
    int i;
    for (i=0; i<N; i++)    {
        printf("Elment %d : ", i);
        scanf("%d", &A[i]);
    }
}

/* afficher le contenu d'un tableau A de N positions */
void affiche (int A[], int N) {
    int i;
    for (i=0; i<N; i++)
        printf("%d ", A[i]);
}

/* donne la valeur minimal contenue dans le tableau A de N positions */
int minimum (int A[], int N) {
    int pos_min;   /* position du pos_minimum */
    int i;

    pos_min=0;
    for (i=0; i<N; i++)  {
        if (A[i]<A[pos_min]) pos_min=i;
    }

    return (A[pos_min]);
}

/* donne la valeur max contenue dans le tableau A de N positions */
int maximum (int A[], int N) {
    int pos_max;   /* position du pos_maximum */
    int i;

    pos_max=0;
    for (i=0; i<N; i++) {
        if (A[i]>A[pos_max]) pos_max=i;
    }
    return (A[pos_max]);
}

/* calcul de la mooyenne */
float moyenne (int A[], int N) {
    float moy = 0.0;
    float sum = 0.0;
    int i;

    for (i=0; i<N; i++) {
        sum += A[i];
    }
    moy = sum/N;
    return (moy);
}


int main()
{
    /* Dclarations */
    int A[MAX]; /* tableau donn  */
    int N;      /* dimension      */
    int I;      /* indice courant */
    int min, max;  /* valeur min et max */
    float moy;     /* moyenne */

    /* Saisie des donnes */
    printf("Dimension du tableau (MAX %d) : ", MAX);
    scanf("%d", &N );
    entree_int(A,N);

    /* Affichage du tableau */
    printf("Tableau donn :\n");
    affiche(A, N);
    printf("\n");

    /* Recherche du pos_maximum et du pos_minimum */
    min = minimum (A, N);
    max = maximum (A, N);
    moy = moyenne (A, N);

    /* Edition du rsultat */
    printf("Valeur minimum : %d\n", min);
    printf("Valeur maximum : %d\n", max);
    printf("Valeur moyenne : %f\n", moy);
    return 0;
}
