#include <stdio.h>
#include <math.h>

#define MAX 10

float polynome (float A[], int n, float x);
float polyHorner (float A[], int n, float x);


/* Mthode traditionnelle
 * float A : coefficients
 * int n : dimension de A (taille)
 * float x : valeur de x
 * */
float polynome (float A[], int n, float x) {
    int i;
    float c=0;
    for (i=0;i<n;i++) {
        c=c+A[i]*pow(x,i);
    }
    return (c);
}


/* methode de Hrner
 * float A : coefficients
 * int n : dimension de A (taille)
 * float x : valeur de x
 * */
float polyHorner (float A[], int n, float x) {
    int i;
    float c;
    c=0;
    for (i=n-1;i>=0;i--) {
         c = c * x + A[i];
    }
    return (c);
}

int main()
{
    float x,c;
    int i,n;
    float A[MAX];

    printf("Donner le degr du polynme : \n");
    scanf("%i",&n);

    //les dimensions du vecteur A sera n+1: a0 + a1X1 + ... + anXn
    n += 1;

    for (i=0;i<n;i++) {
        printf("A[%i] ? ",i);
        scanf("%f",&A[i]);
    }

    printf("Donner la valeur de X : ");
    scanf("%f",&x);

    c = polynome (A, n, x);
    printf("La valeur de P(%f) est : %f\n",x, c);
    c = polyHorner (A, n, x);
    printf("La valeur de P(%f) est : %f\n",x,c);

    return 0;
}
