#include <stdio.h>
#include <math.h>
#include "td3.h"

void afficheSin (double a, double b, double pas, int k, int espaces) {
   double x, sinx;
   int i;

   x = a;
   while (x<=b) {
       sinx = approsin(x,k);

       espaces = (int) ((sinx*10)+10);

       printf ("%.1lf |",x);
       for (i=0; i<espaces; i++)
           printf(" ");
       printf("* \n");

       x += pas;
   }
}


void tableauSin (double a, double b, double pas, int k) {
   double x, sinx;
   int i;

    printf ("Sin(x) de %lf a %lf (k=%d)\n",a,b,k);

    x=a;
    while (x <= b) {
        sinx = approsin(x, k);
        printf ("sin (%lf) = %lf (%lf)\n", x, sinx, sin(x));
        x += pas;
    }

}

int main ()
{
    double a,b;
    double pas = 0.5;
    double x, sinx;
    int k = 5, espaces=40;

    printf ("Entrez a b :");
    scanf ("%lf %lf",&a,&b);

    tableauSin(a,b,pas,k);
    afficheSin(a,b,pas,k,espaces);
}
