#include <stdio.h>

int factoriel (int x)
{
    int fact;
    if (x==0) fact = 1;
    else
        fact = x * factoriel (x-1);
    //printf ("R: %d ! = %d \n", x, fact);
    return (fact);
}

int factorielNonRec (int x)
{
    int fact = 1, i;
    for (i=1; i<=x; i++)
        fact *= i;

    //printf ("%d ! = %d \n", x, fact);
    return (fact);
}

float coefbinomial (int n, int k) {
    float c_nk;

    if (k==0)
        c_nk = 0;
    else {
        c_nk = factoriel(n) / (factoriel(k)*factoriel(n-k));
    }
    //printf ("%f\n",c_nk);
    return c_nk;
}


float coefbinomialNonRec (int n, int k) {
   float c_nk;

    if (k==0)
        c_nk = 0;
    else {
        c_nk = factorielNonRec(n) / (factorielNonRec(k)*factorielNonRec(n-k));
    }
    //printf ("%f\n",c_nk);
    return c_nk;
}

float coefdevelop (int a, int b, int n) {
    int i;
    float sum = 0;

    printf ("%d %d %d\n", a,b,n);
    for (i=0; i<=n; i++) {
        sum += (coefbinomial(n, i) * pow(a, (n-i)) * pow (b,i));
     }

    return sum;
}


int main ()
{
    int n, k, a, b;
    int K=6;

    printf ("Entrez n k : ");
    scanf ("%d%d", &n, &k);

    if (n>=k) {
      printf ("C%d-%d = %f (Rec) %f (Non-Rec)\n",n,k, coefbinomial(n,k), coefbinomialNonRec(n,k));
    }

    printf ("Entrez a b : ");
    scanf ("%d%d", &a,&b);

    printf ("P(a,b) = (a + b)^%d pour (%d, %d) = %f\n", a, b, K, coefdevelop(a,b,K));

}
