#include <stdio.h>

/*  DST : prob 2 100% Algebre
 * pour deux n entiers a et b, avec a>b et b>0
 * (a + b) + (a-b) + (a*b) + (a/b) = 16807
 *  2a + ab + a/b = 16807
 * si b = 1 (plus petite valeur pour b)
 *  2a + a*1 + a/1 = 16807
 *  2a + a + a = 16807
 *  4a = 16807
 *  a = 4201
 *  donc a aura au grand maximum une valeur de 4201
 *  donc a>0 et a<4202
 *
 */

int main () {
  unsigned long a,b, c;
  //selon le raisonnement ci-dessous, on sait que a>0 et a<4202
  for ( a=2; a<4202 ; a++ ) {
     //dans la definition du probleme, on dit qu'on soustrait et divise
     //la + grande valeur par la + petite, donc si on fait
     //a - b et a/b ca veut bien dire qu'on suppose
     //a>b, et donc b>=1 et b<a
     for (b=1; b<a; b++) {
        //c = 2a + ab + a/b
        c = 2*a + a*b + a/b;
        if (c == 16807) {
           printf ("Trouve! a=%ld et b=%ld\n", a,b);
        }
     }
  }
}
